

subroutine Sum (method, state, in, out)
dll_export Sum
integer(4), value :: method 
integer(4) state
real(8) in(*), out(*), x, y

if (method.eq.0) then 		!Initialize
	continue
elseif (method.eq.2) then 	!Report version
	out(1) = 1.0
elseif (method.eq.3) then	!Report arguments
	out(1) = 2		!Two incoming arguments
	out(2) = 1		!One outgoing argument
elseif (method.eq.1) then	!Calculate
	x = in(1)		
	y = in(2)
	out(1) = x + y
elseif (method.eq.99) then	!Cleanup
	continue
!else
!	write(10,*)'FortranDLL was called with an invalid argument'
endif
end


subroutine ProdSum (method, state, in, out)
dll_export ProdSum
integer(4), value :: method 
integer(4) state
real(8) in(*), out(*), x, y

if (method.eq.0) then 		!Initialize
	continue
elseif (method.eq.2) then 	!Report version
	out(1) = 1.0
elseif (method.eq.3) then	!Report arguments
	out(1) = 2		!Two incoming arguments
	out(2) = 2		!Two outcoming arguments
elseif (method.eq.1) then	!Calculate
	x = in(1)
	y = in(2)
	out(1) = x + y		!Sum
	out(2) = x * y		!Product
elseif (method.eq.99) then	!Cleanup
	continue
!else
!	write(10,*)'FortranDLL was called with an invalid argument'
endif
end


subroutine Half(method, state, in, out)
dll_export Half
integer(4), value :: method 
integer(4) state
real(8) in(*), out(*), x, y

if (method.eq.0) then 		!Initialize
	continue
elseif (method.eq.2) then 	!Report version
	out(1) = 1.0
elseif (method.eq.3) then	!Report arguments
	out(1) = 1		!One incoming arguments
	out(2) = 1		!One outcoming arguments
elseif (method.eq.1) then	!Calculate
	out(1) = FuncHalf(in(1))!Sum
elseif (method.eq.99) then	!Cleanup
	continue
!else
!	write(10,*)'FortranDLL was called with an invalid argument'
endif
end

function FuncHalf(x)
real(8) x
	FuncHalf = x / 2
end